<?php

/**
 * prepare "Initialization Vector" param, that should match the value from E6 UrlLoginPlugin
 */
$iv = @$_GET['iv'];

/**
 * prepare "Shared Key" param, that should match the value from E6 UrlLoginPlugin, optionally
 * it may be the value from a file, configured for the plugin
 */
$key = @$_GET['key'];

/**
 * prepare credentials, passed in the form username:password
 * add expiration timestamp which is 60 seconds from now
 */
$credentials = @$_GET['credentials']. ':' . (time() + 60);

/**
 * make sure all the parameters are set
 */
if (strlen($iv) < 16 || !$key || !$credentials) {
    exit('Parameters are missing');
}

/**
 * pad/truncate to 32 characters
 */
$key = str_pad(substr($key, 0, 32), 32, "0");

/**
 * open a module with certain algorithm and mode
 */
$cipher = mcrypt_module_open(MCRYPT_RIJNDAEL_128, null, MCRYPT_MODE_CBC, null);

/**
 * initialize encryption buffers
 */
mcrypt_generic_init($cipher, $key, $iv);

/**
 * encrypt credentials
 */
$cipherText = mcrypt_generic($cipher, $credentials);

/**
 * unpack data from binary string using hex string, high nibble first format and
 * stringify it
 */
$cipherBlock = implode(unpack('H*', $iv . $cipherText));

/**
 * deinit and close module
 */
mcrypt_generic_deinit($cipher);
mcrypt_module_close($cipher);

exit($cipherBlock);